CREATE OR REPLACE procedure opt_lock_centry (
   iempno in varchar2 default null ) is

   emp_rec scott.emp%ROWTYPE;
   rec_row_id rowid;
   csum number;

begin
   -- Fetch the record and rowid the employee with the give id
   select * into emp_rec from scott.emp where emp.empno = iempno;
   select rowid into rec_row_id from scott.emp where emp.empno = iempno;
   -- Create a simple data entry form
   htp.print('<form action=opt_lock_cupdate>');
   htp.formHidden(cname=>'iempno', cvalue => iempno);
   htp.formHidden(cname=>'irowid', cvalue => rec_row_id);
   htp.print('Employee Name:');
   htp.formText(cname => 'iename', cvalue=> emp_rec.ename);
   htp.print('Job:');
   htp.formText(cname => 'ijob', cvalue=> emp_rec.job);
   -- Calculate the checksum for the row and save as a hidden field
   csum := owa_opt_lock.checksum('SCOTT', 'emp', rec_row_id);
   htp.formHidden(cname=>'iold_checksum', cvalue => csum);
   htp.print('<input type=submit>');
   htp.print('</form>');
end;
 
/

